// Copyright (C) 2006 Pushok Software http://www.pushok.com/soft_svncom.php
//
// LICENSE
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License (GPL)
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// To read the license please visit http://www.gnu.org/copyleft/gpl.html
//
// Subversion is Copyrght of(c) 2000-2004 CollabNet.  All rights reserved.
// Full license available here http://subversion.tigris.org/license-1.html.

#pragma once

template<class T>
class CProxy_ISVNAuthProviderEvents :
	public IConnectionPointImpl<T, &__uuidof(_ISVNAuthProviderEvents)>
{
public:
	HRESULT Fire_AskEvent( SVNAuthProviderAsk  nAsk,  ISVNAuthProvider *  pProvider)
	{
		HRESULT hr = S_OK;
		T * pThis = static_cast<T *>(this);
		int cConnections = m_vec.GetSize();

		for (int iConnection = 0; iConnection < cConnections; iConnection++)
		{
			pThis->Lock();
			CComPtr<IUnknown> punkConnection = m_vec.GetAt(iConnection);
			pThis->Unlock();

			_ISVNAuthProviderEvents * pConnection = static_cast<_ISVNAuthProviderEvents *>(punkConnection.p);

			if (pConnection)
				hr = pConnection->AskEvent(nAsk,pProvider);
		}
		return hr;
	}
};

